package com.mortals.xhx.module.window.web;

import com.mortals.framework.common.Rest;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.base.system.user.model.UserQuery;
import com.mortals.xhx.base.system.user.service.UserService;
import com.mortals.xhx.common.code.YesNoEnum;
import com.mortals.xhx.common.pdu.RespData;
import com.mortals.xhx.common.pdu.site.SiteHallPdu;
import com.mortals.xhx.common.pdu.window.WindowPdu;
import com.mortals.xhx.feign.site.ISiteHallFeign;
import com.mortals.xhx.feign.window.IWindowFeign;
import com.mortals.xhx.module.dept.model.DeptQuery;
import com.mortals.xhx.module.dept.service.DeptService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.window.model.WindowOwnerEntity;
import com.mortals.xhx.module.window.service.WindowOwnerService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.alibaba.fastjson.JSONObject;

import java.util.Arrays;

import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import static com.mortals.framework.ap.SysConstains.*;

/**
 * 窗口负责人
 *
 * @author zxfei
 * @date 2023-07-12
 */
@RestController
@RequestMapping("window/owner")
public class WindowOwnerController extends BaseCRUDJsonBodyMappingController<WindowOwnerService, WindowOwnerEntity, Long> {

    @Autowired
    private ParamService paramService;
    @Autowired
    private UserService userService;
    @Autowired
    private DeptService deptService;

    @Autowired
    private IWindowFeign windowFeign;
    
    @Autowired
    private ISiteHallFeign siteHallFeign;

    public WindowOwnerController() {
        super.setModuleDesc("窗口负责人");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {

        SiteHallPdu siteHallPdu = new SiteHallPdu();
        siteHallPdu.setSiteId(1L);
        Rest<RespData<List<SiteHallPdu>>> rest = siteHallFeign.list(siteHallPdu);
        if(YesNoEnum.YES.getValue()==rest.getCode()){
            Map<Long, String> hallMap = rest.getData().getData().stream().collect(Collectors.toMap(x -> x.getId(), y -> y.getHallName(), (o, n) -> n));
            this.addDict(model, "hallId", hallMap);
        }

//        Map<String, String> collect = userService.find(new UserQuery(), getContext()).stream()
//                .collect(Collectors.toMap(x -> x.getId().toString(), y -> y.getRealName(), (o, n) -> n));
//        this.addDict(model, "updateUserId", collect);
        this.addDict(model, "deptId", deptService.getDeptBySalaId(-1l).stream().collect(Collectors.toMap(x->x.getId().toString(), y->y.getDeptName(),(o, n)->n)));
        this.addDict(model, "salaId", deptService.getAllSala().stream().collect(Collectors.toMap(x->x.getId().toString(), y->y.getDeptName(),(o, n)->n)));

        super.init(model, context);
    }

    @PostMapping({"subWindowList"})
    public Rest<Object> subWindowList(@RequestBody WindowPdu query) {
        Rest<Object> ret = new Rest();
        Map<String, Object> model = new HashMap();
        Context context = this.getContext();
        String busiDesc = "查询待分配的窗口列表";

        int code = 1;
        try {
            //查询所有可以选择的窗口
            List<WindowPdu> result = this.getService().subWindowPduList(query);
            //查询当前负责人已经选择的窗口
            model.put("data", result);
            model.put("message_info", busiDesc + "成功");
            this.recordSysLog(this.request, busiDesc + " 【成功】");
        } catch (Exception var9) {
            code = -1;
            this.doException(this.request, busiDesc, model, var9);
        }

        this.init(model, context);
        ret.setCode(code);
        ret.setData(model);
        ret.setDict(model.get("dict"));
        ret.setMsg(model.get("message_info") == null ? "" : model.remove("message_info").toString());
        return ret;
    }


}